<?php
/**
 * Tine 2.0
 *
 * @package     Tinebase
 * @subpackage  Converter
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @copyright   Copyright (c) 2019 Metaways Infosystems GmbH (http://www.metaways.de)
 * @author      Paul Mehrer <p.mehrer@metaways.de>
 */

/**
 * Tinebase_Model_Converter_DateTimeFakeNull
 *
 * DateTimeFakeNull Converter
 *
 * @package     Tinebase
 * @subpackage  Converter
 */

class Tinebase_Model_Converter_DateTimeFakeNull implements Tinebase_Model_Converter_RunOnNullInterface
{
    /**
     * @param $blob
     * @return mixed
     */
    public function convertToRecord($record, $key, $blob)
    {
        return (string)$blob === '1970-01-01 00:00:00' || !$blob ? null : new Tinebase_DateTime($blob);
    }

    /**
     * @param $fieldValue
     * @return string
     */
    public function convertToData($record, $key, $fieldValue)
    {
        if (null === $fieldValue) {
            return '1970-01-01 00:00:00';
        }
        return $fieldValue;
    }
}
